/* Copyright (c) 1994-95 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This source file is part of the Wisconsin Wind Tunnel,
 * originally written by Steven K. Reinhardt and David A. Wood,
 * and subsequently maintained and enhanced by Steven K. Reinhardt,
 * Babak Falsafi, and Alvin R. Lebeck.
 *
 * Author: Satish Chandra, 1994
 * Derived from the shared memory version by Satish Chandra and
 * Steve Dirkse (University of Wisconsin Madison)
 */

/* -*- C -*- */

typedef struct MCS_booltreenode_tag {

  volatile int parentsense;
  int pad1[7];

  volatile int *parentpointer;
  volatile int *childpointer1;
  volatile int *childpointer2;
  volatile int havechild1, havechild2;
  int dummy;
  int pad2[2];

  volatile int cnotready1;
  int pad3[7];

  volatile int cnotready2;
  int pad4[7];

} MCS_booltreenode_t;

typedef struct MCS_doubletreenode_tag {
  volatile double nodedata;
  int pad1[6];

  volatile double *parentpointer;
  volatile double *rootdatapointer;
  double dummy;
  int pad2[4];

  volatile double childdata1;
  int pad3[6];

  volatile double childdata2;
  int pad4[6];
} MCS_doubletreenode_t;

typedef struct MCS_double_reduc_tag {
  MCS_booltreenode_t *bool_node;  /* this is in shared segment */
  MCS_doubletreenode_t *double_node; /* also in shared segment */
  int sense; /* private */
  double mydata; /* private */
  BARDEC(reduc_bar)
} MCS_double_reduc_t;

#define MAX_OP 1

#define DOUBLE_REDUC_DEC(fr)         MCS_double_reduc_t fr;
#define INIT_DOUBLE_REDUC(fr)        init_double_reduc(&fr)
#define DOUBLE_REDUCTION(fr, fp, op) perform_double_reduc(&fr, fp, op)

  
#ifndef TRUE
#define TRUE (1)
#endif
#ifndef FALSE
#define FALSE (0)
#endif
