/* Copyright (c) 1994-95 by Mark Hill, James Larus, and David Wood for
 * the Wisconsin Wind Tunnel Project.
 *
 * ALL RIGHTS RESERVED.
 *
 * This software is furnished under a license and may be used and
 * copied only in accordance with the terms of such license and the
 * inclusion of the above copyright notice.  This software or any other
 * copies thereof or any derivative works may not be provided or
 * otherwise made available to any other persons.  Title to and ownership
 * of the software is retained by Mark Hill, James Larus, and David Wood.
 * Any use of this software must include the above copyright notice.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS".  THE LICENSOR MAKES NO
 * WARRANTIES ABOUT ITS CORRECTNESS OR PERFORMANCE.
 *
 * This source file is part of the Wisconsin Wind Tunnel,
 * originally written by Steven K. Reinhardt and David A. Wood,
 * and subsequently maintained and enhanced by Steven K. Reinhardt,
 * Babak Falsafi, and Alvin R. Lebeck.
 *
 */
/*----------------------------*/
/* my.h                       */
/*----------------------------*/
/* C header file with         */ 
/* general definitions        */
/*----------------------------*/
#ifdef SINGLEPREC
#  define FPTYPE float
#  define FPMASK "%f"
#else
#  define FPTYPE double
#  define FPMASK "%lf"
#endif
#define USHORT unsigned short
#define SHORT short
#define ULONG unsigned long
#define LONG long
#define INT long
#define BOOL unsigned short

#define PI 3.14159265358979323844
#ifndef RAND_MAX
#  define RAND_MAX 2147483648
#endif

#define max(a,b) ( ((a)>(b)) ? (a) : (b) )
#define min(a,b) ( ((a)<(b)) ? (a) : (b) )
#define SQR(x) ((x)*(x))
#define AABS(x) sqrt(SQR(x[0]) + SQR(x[1]) + SQR(x[2]))
#define DELTA(i,j) (((i) == (j)) ? 1.0 : 0.0)

#define FILENAM_SIZE 80
#define STRING_SIZE 80

#ifndef WWT
# ifndef XX_NUM_NODES
#   define XX_NUM_NODES 1
# endif
# ifndef G_MALLOC
#   define G_MALLOC(ulSize) malloc(ulSize);      
# endif
#endif
